from .party import (
    missing_brackets,
    remove_case,
    remove_etal,
    remove_etc,
    remove_supra,
    uniform_replacements,
)


def defendant(text: str) -> str:

    text = text.strip(";, ")

    # must remove "supra" before reaching "case"
    text = remove_supra(text)

    # must remove "case" before reaching "et. al."
    text = remove_case(text)

    # must remove "et al" before reaching "etc."
    text = remove_etal(text)

    # must remove "etc." before reaching possible punctuation marks
    text = remove_etc(text)

    # usually immediate
    text = text.rstrip(":,”' ")

    # deal with missing brackets
    text = missing_brackets(text)

    # make replacements
    text = uniform_replacements(text)

    return text
